/*
Copyright Ideaconsult Ltd. (C) 2005-2007  

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
package chemCast.data;

import java.util.ArrayList;

import org.openscience.cdk.interfaces.IChemObject;

public class MultipleFilters<T extends IObjectFilter> extends AbstractFilter  {
	protected ArrayList<T> filters;

	public MultipleFilters(ArrayList<T> filters) {
		super();
		setFilters(filters);
	}
	
	public MultipleFilters() {
		super();
		setFilters(new ArrayList<T>());
	}
	
	public boolean accept(IChemObject object) {
		for (int i=0; i < filters.size();i++)
			if (!filters.get(i).accept(object)) return false;
		return true;	
	}

	public ArrayList<T> getFilters() {
		return filters;
	}

	public void setFilters(ArrayList<T> filters) {
		this.filters = filters;
	}
	public void addFilter(T filter) {
		filters.add(filter);
	}

}


