/*
Copyright (C) 2005-2006  

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation; either version 2.1
of the License, or (at your option) any later version.
All we ask is that proper credit is given for our work, which includes
- but is not limited to - adding the above copyright notice to the beginning
of your source code files, and to any copyright notice that you may distribute
with programs based on this work.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*/

package chemCast.similarity.data;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.LayoutManager;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import ambit.data.IAmbitEditor;
import ambit.exceptions.AmbitException;

public class DefaultChemCastEditor extends JPanel implements IAmbitEditor {
	/**
	 * 
	 */
	private static final long serialVersionUID = -5047904516589635601L;
	protected String title;
	protected boolean editable=false;

	public DefaultChemCastEditor(LayoutManager layout ,String title,IChemCastObject object) {
		super(layout);
		this.title = title;
	    setName(object.toString());
	}
	
	public DefaultChemCastEditor(String title,IChemCastObject object) {
		this(new BorderLayout(),title,object);
	}

    public boolean view(Component parent, boolean editable, String title) throws AmbitException {
    	setEditable(editable);
        return JOptionPane.showConfirmDialog(parent, getJComponent(),title,JOptionPane.OK_CANCEL_OPTION,JOptionPane.PLAIN_MESSAGE) == JOptionPane.OK_OPTION;
    }
	public JComponent getJComponent() {
		return this;
	}

	public boolean isEditable() {
		return editable;
	}

	public void setEditable(boolean editable) {
		this.editable = editable;
	}

}



