package chemCast.similarity.data;

import ambit.processors.results.LightSimilarityMatrix;
import ambit.similarity.ISimilarityProcessor;

public class SubsetSimilarityMatrix extends LightSimilarityMatrix {
	protected Subset rows_data;
	protected Subset columns_data;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -8845066460682783242L;

	public SubsetSimilarityMatrix(ISimilarityProcessor processor) {
		super(processor);

	}

	public SubsetSimilarityMatrix(Subset rows,
			Subset columns, ISimilarityProcessor processor) throws Exception {
		super(rows.getData(), columns.getData(), processor);
		setRows_data(rows);
		setColumns_data(columns);
	}

	public Subset getColumns_data() {
		return columns_data;
	}

	public void setColumns_data(Subset columns_data) {
		try {
			this.columns_data = columns_data;
			if (columns_data == null)
				setColumns(null);
			else
				setColumns(columns_data.getData());
		} catch (Exception x) {
			this.columns_data = null;
			setColumns(null);			
		}
	}

	public Subset getRows_data() {
		return rows_data;
	}

	public void setRows_data(Subset rows_data) {
		
		try {
			this.rows_data = rows_data;
			if (rows_data == null)
				setRows(null);
			else	
				setRows(rows_data.getData());
		} catch (Exception x) {
			this.rows_data = null;
			setRows(null);			
		}
	}
	public void clear() {
		setColumns_data(null);
		setRows_data(null);
		fireTableStructureChanged();
	}

	/*
	public float calcValueAt(int row, int column) throws Exception {
		System.out.println(row + "," + column);
		return Tanimoto.calculate(
				(BitSet)rows.getProperty(row,AmbitCONSTANTS.Fingerprint),
				(BitSet)columns.getProperty(column,AmbitCONSTANTS.Fingerprint));
		
	}
	*/
}
