/* FileNewTrainingAction.java
 * Author: Nina Jeliazkova
 * Date: Feb 17, 2007 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.ui.actions;

import javax.swing.Icon;
import javax.swing.JFrame;

import ambit.ui.UITools;
import chemCast.application.ChemCASTModule;
import chemCast.application.StatusBar;
import chemCast.exception.SubsetException;
import chemCast.similarity.data.DatasetDef;
import chemCast.similarity.data.Endpoint;
import chemCast.similarity.data.Endpoints;

public class FileNewTrainingAction extends TrainingSetOpenAction {
    /**
     * 
     */
    private static final long serialVersionUID = 4175265062477710970L;

    public FileNewTrainingAction(ChemCASTModule userData, JFrame mainFrame, int dataset) {
        this(userData, mainFrame, "New", dataset);
    }

    public FileNewTrainingAction(ChemCASTModule userData, JFrame mainFrame,
            String name, int dataset) {
        this(userData, mainFrame, name, UITools.createImageIcon("ambit/ui/images/new_document_16_h.png"), dataset);
    }

    public FileNewTrainingAction(ChemCASTModule userData, JFrame mainFrame,
            String name, Icon icon, int dataset) {
        super(userData, mainFrame, name, icon, dataset);
    }

    @Override
    public DatasetDef getDataset() throws SubsetException {
        getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Status,null,"Reading endpoints");
        Endpoints endpoints = ChemCASTModule.readEndpoints();
        subsets.clear();
        Endpoint endpoint = endpoints.findByName("New");
        if (endpoint != null) {
            ((ChemCASTModule) userData).setEndpoint(endpoint);
            getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Status,null,endpoint.getTrainingData()+" selected");
            DatasetDef dataset = endpoint.getTrainingData();
            dataset.setDatasetSource(DatasetDef.p_memorysource);
            return dataset;
            
        } else {
            getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Status,null," ");
            return null;
        }

    }    

}
