/* ChemCASTAction.java
 * Author: Nina Jeliazkova
 * Date: Oct 1, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.ui.actions;

import java.awt.event.ActionEvent;

import javax.swing.Icon;
import javax.swing.JFrame;

import ambit.ui.actions.AmbitAction;
import chemCast.application.ChemCASTModule;
import chemCast.application.StatusBar;
import chemCast.similarity.data.Subsets;

public abstract class ToxmatchAction extends AmbitAction {

    /**
     * 
     */
    private static final long serialVersionUID = -757408395206111133L;
    protected int dataset = ChemCASTModule.DATA_TRAINING;   
    public ToxmatchAction(ChemCASTModule userData, JFrame mainFrame,
            int dataset) {
        this(userData, mainFrame,"ChemCAST", dataset);
        
    }

    public ToxmatchAction(ChemCASTModule userData, JFrame mainFrame,
            String name, int dataset) {
        this(userData, mainFrame, name,  null,
                dataset);
        
    }

    public ToxmatchAction(ChemCASTModule userData, JFrame mainFrame,
            String name, Icon icon, int dataset) {
        super(userData, mainFrame, name, icon);
        this.dataset = dataset;
        
    }
    ChemCASTModule getChemCastData() {
        return (ChemCASTModule) userData;
    }
    
    @Override
    public void run(ActionEvent arg0) {
        super.run(arg0);
        getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Status,null,toString());
        getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Processing,null,new Boolean(true));
        try {
	        processDataset(getChemCastData().getDataset(dataset));
	        
	        getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Processing,null,new Boolean(false));        
	        getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Status,null,"");
        } catch (Exception x) {
        	getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Processing,null,new Boolean(false));        
	        getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Error,null,x);
        }
    }
    protected abstract void processDataset(Subsets data) throws Exception  ;
    @Override
    public String toString() {
    	return getValue(NAME).toString();
    }

}
