/*
Copyright (C) 2005-2006  

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation; either version 2.1
of the License, or (at your option) any later version.
All we ask is that proper credit is given for our work, which includes
- but is not limited to - adding the above copyright notice to the beginning
of your source code files, and to any copyright notice that you may distribute
with programs based on this work.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*/

package chemCast.weka;

import ambit.similarity.IDistanceFunction;
import weka.core.DistanceFunction;
import weka.core.EuclideanDistance;
import weka.core.Instance;
import weka.core.Instances;

public abstract class AbstractSimilarity extends EuclideanDistance implements DistanceFunction, IDistanceFunction<Instance>{
	
	public AbstractSimilarity() {
		super();
	}
	public AbstractSimilarity(Instances data) {
		super(data);
	}


	public void update(Instance arg0) throws Exception {
		throw new Exception("Not implemented!");
	}

	protected double zAA(Instance instanceA) {
	    double sum = 0;
	    for(int i = 0; i < m_Data.numAttributes(); i++) {
	    	if (i == m_Data.classIndex()) continue;
	    	if (instanceA.isMissing(i)) continue;
		    if (m_Data.attribute(i).isNominal()) {
		    	sum += 1;
		    } else {
		    	sum += instanceA.value(i)*instanceA.value(i);
		    }
	    }
	    return sum;
	}
	protected double zAB(Instance instanceA, Instance instanceB) {
	    double sum = 0;
	    for(int i = 0; i < m_Data.numAttributes(); i++) {
	    	if (i == m_Data.classIndex()) continue;
	    	if (instanceA.isMissing(i)) continue;
		    if (m_Data.attribute(i).isNominal()) {
		    	if (instanceA.value(i) == instanceB.value(i)) sum ++;
		    } else {
		    	sum += instanceA.value(i)*instanceB.value(i);
		    }
	    }
	    return sum;
	}	

	/*
	      if (m_Train.attribute(i).isNominal()) {

		// If attribute is nominal
		if (first.isMissing(i) || second.isMissing(i) ||
		    ((int)first.value(i) != (int)second.value(i))) {
		  distance += 1;
		  */
    public double similarity2distance(double similarity) {
        return 1-similarity;
    }
    public double distance2similarity(double distance) {
        return 1-distance;
    }

}


